<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfRateAccessorialItem ArrayType
 * @subpackage Arrays
 */
class ArrayOfRateAccessorialItem extends AbstractStructArrayBase
{
    /**
     * The RateAccessorialItem
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\RateAccessorialItem[]
     */
    public $RateAccessorialItem;
    /**
     * Constructor method for ArrayOfRateAccessorialItem
     * @uses ArrayOfRateAccessorialItem::setRateAccessorialItem()
     * @param \StructType\RateAccessorialItem[] $rateAccessorialItem
     */
    public function __construct(array $rateAccessorialItem = array())
    {
        $this
            ->setRateAccessorialItem($rateAccessorialItem);
    }
    /**
     * Get RateAccessorialItem value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\RateAccessorialItem[]|null
     */
    public function getRateAccessorialItem()
    {
        return isset($this->RateAccessorialItem) ? $this->RateAccessorialItem : null;
    }
    /**
     * This method is responsible for validating the values passed to the setRateAccessorialItem method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRateAccessorialItem method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateRateAccessorialItemForArrayConstraintsFromSetRateAccessorialItem(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfRateAccessorialItemRateAccessorialItemItem) {
            // validation for constraint: itemType
            if (!$arrayOfRateAccessorialItemRateAccessorialItemItem instanceof \StructType\RateAccessorialItem) {
                $invalidValues[] = is_object($arrayOfRateAccessorialItemRateAccessorialItemItem) ? get_class($arrayOfRateAccessorialItemRateAccessorialItemItem) : sprintf('%s(%s)', gettype($arrayOfRateAccessorialItemRateAccessorialItemItem), var_export($arrayOfRateAccessorialItemRateAccessorialItemItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The RateAccessorialItem property can only contain items of type \StructType\RateAccessorialItem, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set RateAccessorialItem value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\RateAccessorialItem[] $rateAccessorialItem
     * @return \ArrayType\ArrayOfRateAccessorialItem
     */
    public function setRateAccessorialItem(array $rateAccessorialItem = array())
    {
        // validation for constraint: array
        if ('' !== ($rateAccessorialItemArrayErrorMessage = self::validateRateAccessorialItemForArrayConstraintsFromSetRateAccessorialItem($rateAccessorialItem))) {
            throw new \InvalidArgumentException($rateAccessorialItemArrayErrorMessage, __LINE__);
        }
        if (is_null($rateAccessorialItem) || (is_array($rateAccessorialItem) && empty($rateAccessorialItem))) {
            unset($this->RateAccessorialItem);
        } else {
            $this->RateAccessorialItem = $rateAccessorialItem;
        }
        return $this;
    }
    /**
     * Add item to RateAccessorialItem value
     * @throws \InvalidArgumentException
     * @param \StructType\RateAccessorialItem $item
     * @return \ArrayType\ArrayOfRateAccessorialItem
     */
    public function addToRateAccessorialItem(\StructType\RateAccessorialItem $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\RateAccessorialItem) {
            throw new \InvalidArgumentException(sprintf('The RateAccessorialItem property can only contain items of type \StructType\RateAccessorialItem, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->RateAccessorialItem[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\RateAccessorialItem|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\RateAccessorialItem|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\RateAccessorialItem|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\RateAccessorialItem|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\RateAccessorialItem|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string RateAccessorialItem
     */
    public function getAttributeName()
    {
        return 'RateAccessorialItem';
    }
}
