<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ProcessXML StructType
 * @subpackage Structs
 */
class ProcessXML extends AbstractStructBase
{
    /**
     * The xmlRequest
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $xmlRequest;
    /**
     * Constructor method for ProcessXML
     * @uses ProcessXML::setXmlRequest()
     * @param string $xmlRequest
     */
    public function __construct($xmlRequest = null)
    {
        $this
            ->setXmlRequest($xmlRequest);
    }
    /**
     * Get xmlRequest value
     * @return string|null
     */
    public function getXmlRequest()
    {
        return $this->xmlRequest;
    }
    /**
     * Set xmlRequest value
     * @param string $xmlRequest
     * @return \StructType\ProcessXML
     */
    public function setXmlRequest($xmlRequest = null)
    {
        // validation for constraint: string
        if (!is_null($xmlRequest) && !is_string($xmlRequest)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($xmlRequest, true), gettype($xmlRequest)), __LINE__);
        }
        $this->xmlRequest = $xmlRequest;
        return $this;
    }
}
