<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TerminalItem StructType
 * @subpackage Structs
 */
class TerminalItem extends AbstractStructBase
{
    /**
     * The CityDispatchPhone
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var float
     */
    public $CityDispatchPhone;
    /**
     * The CustomerServicePhone
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var float
     */
    public $CustomerServicePhone;
    /**
     * The TollFreePhone
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var float
     */
    public $TollFreePhone;
    /**
     * The Fax
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var float
     */
    public $Fax;
    /**
     * The ID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ID;
    /**
     * The Name
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Name;
    /**
     * The Manager
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Manager;
    /**
     * The Address1
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Address1;
    /**
     * The Address2
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Address2;
    /**
     * The City
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $City;
    /**
     * The State
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $State;
    /**
     * The Zipcode
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Zipcode;
    /**
     * Constructor method for TerminalItem
     * @uses TerminalItem::setCityDispatchPhone()
     * @uses TerminalItem::setCustomerServicePhone()
     * @uses TerminalItem::setTollFreePhone()
     * @uses TerminalItem::setFax()
     * @uses TerminalItem::setID()
     * @uses TerminalItem::setName()
     * @uses TerminalItem::setManager()
     * @uses TerminalItem::setAddress1()
     * @uses TerminalItem::setAddress2()
     * @uses TerminalItem::setCity()
     * @uses TerminalItem::setState()
     * @uses TerminalItem::setZipcode()
     * @param float $cityDispatchPhone
     * @param float $customerServicePhone
     * @param float $tollFreePhone
     * @param float $fax
     * @param string $iD
     * @param string $name
     * @param string $manager
     * @param string $address1
     * @param string $address2
     * @param string $city
     * @param string $state
     * @param string $zipcode
     */
    public function __construct($cityDispatchPhone = null, $customerServicePhone = null, $tollFreePhone = null, $fax = null, $iD = null, $name = null, $manager = null, $address1 = null, $address2 = null, $city = null, $state = null, $zipcode = null)
    {
        $this
            ->setCityDispatchPhone($cityDispatchPhone)
            ->setCustomerServicePhone($customerServicePhone)
            ->setTollFreePhone($tollFreePhone)
            ->setFax($fax)
            ->setID($iD)
            ->setName($name)
            ->setManager($manager)
            ->setAddress1($address1)
            ->setAddress2($address2)
            ->setCity($city)
            ->setState($state)
            ->setZipcode($zipcode);
    }
    /**
     * Get CityDispatchPhone value
     * @return float
     */
    public function getCityDispatchPhone()
    {
        return $this->CityDispatchPhone;
    }
    /**
     * Set CityDispatchPhone value
     * @param float $cityDispatchPhone
     * @return \StructType\TerminalItem
     */
    public function setCityDispatchPhone($cityDispatchPhone = null)
    {
        // validation for constraint: float
        if (!is_null($cityDispatchPhone) && !(is_float($cityDispatchPhone) || is_numeric($cityDispatchPhone))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($cityDispatchPhone, true), gettype($cityDispatchPhone)), __LINE__);
        }
        $this->CityDispatchPhone = $cityDispatchPhone;
        return $this;
    }
    /**
     * Get CustomerServicePhone value
     * @return float
     */
    public function getCustomerServicePhone()
    {
        return $this->CustomerServicePhone;
    }
    /**
     * Set CustomerServicePhone value
     * @param float $customerServicePhone
     * @return \StructType\TerminalItem
     */
    public function setCustomerServicePhone($customerServicePhone = null)
    {
        // validation for constraint: float
        if (!is_null($customerServicePhone) && !(is_float($customerServicePhone) || is_numeric($customerServicePhone))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($customerServicePhone, true), gettype($customerServicePhone)), __LINE__);
        }
        $this->CustomerServicePhone = $customerServicePhone;
        return $this;
    }
    /**
     * Get TollFreePhone value
     * @return float
     */
    public function getTollFreePhone()
    {
        return $this->TollFreePhone;
    }
    /**
     * Set TollFreePhone value
     * @param float $tollFreePhone
     * @return \StructType\TerminalItem
     */
    public function setTollFreePhone($tollFreePhone = null)
    {
        // validation for constraint: float
        if (!is_null($tollFreePhone) && !(is_float($tollFreePhone) || is_numeric($tollFreePhone))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($tollFreePhone, true), gettype($tollFreePhone)), __LINE__);
        }
        $this->TollFreePhone = $tollFreePhone;
        return $this;
    }
    /**
     * Get Fax value
     * @return float
     */
    public function getFax()
    {
        return $this->Fax;
    }
    /**
     * Set Fax value
     * @param float $fax
     * @return \StructType\TerminalItem
     */
    public function setFax($fax = null)
    {
        // validation for constraint: float
        if (!is_null($fax) && !(is_float($fax) || is_numeric($fax))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($fax, true), gettype($fax)), __LINE__);
        }
        $this->Fax = $fax;
        return $this;
    }
    /**
     * Get ID value
     * @return string|null
     */
    public function getID()
    {
        return $this->ID;
    }
    /**
     * Set ID value
     * @param string $iD
     * @return \StructType\TerminalItem
     */
    public function setID($iD = null)
    {
        // validation for constraint: string
        if (!is_null($iD) && !is_string($iD)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($iD, true), gettype($iD)), __LINE__);
        }
        $this->ID = $iD;
        return $this;
    }
    /**
     * Get Name value
     * @return string|null
     */
    public function getName()
    {
        return $this->Name;
    }
    /**
     * Set Name value
     * @param string $name
     * @return \StructType\TerminalItem
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($name, true), gettype($name)), __LINE__);
        }
        $this->Name = $name;
        return $this;
    }
    /**
     * Get Manager value
     * @return string|null
     */
    public function getManager()
    {
        return $this->Manager;
    }
    /**
     * Set Manager value
     * @param string $manager
     * @return \StructType\TerminalItem
     */
    public function setManager($manager = null)
    {
        // validation for constraint: string
        if (!is_null($manager) && !is_string($manager)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($manager, true), gettype($manager)), __LINE__);
        }
        $this->Manager = $manager;
        return $this;
    }
    /**
     * Get Address1 value
     * @return string|null
     */
    public function getAddress1()
    {
        return $this->Address1;
    }
    /**
     * Set Address1 value
     * @param string $address1
     * @return \StructType\TerminalItem
     */
    public function setAddress1($address1 = null)
    {
        // validation for constraint: string
        if (!is_null($address1) && !is_string($address1)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($address1, true), gettype($address1)), __LINE__);
        }
        $this->Address1 = $address1;
        return $this;
    }
    /**
     * Get Address2 value
     * @return string|null
     */
    public function getAddress2()
    {
        return $this->Address2;
    }
    /**
     * Set Address2 value
     * @param string $address2
     * @return \StructType\TerminalItem
     */
    public function setAddress2($address2 = null)
    {
        // validation for constraint: string
        if (!is_null($address2) && !is_string($address2)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($address2, true), gettype($address2)), __LINE__);
        }
        $this->Address2 = $address2;
        return $this;
    }
    /**
     * Get City value
     * @return string|null
     */
    public function getCity()
    {
        return $this->City;
    }
    /**
     * Set City value
     * @param string $city
     * @return \StructType\TerminalItem
     */
    public function setCity($city = null)
    {
        // validation for constraint: string
        if (!is_null($city) && !is_string($city)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($city, true), gettype($city)), __LINE__);
        }
        $this->City = $city;
        return $this;
    }
    /**
     * Get State value
     * @return string|null
     */
    public function getState()
    {
        return $this->State;
    }
    /**
     * Set State value
     * @param string $state
     * @return \StructType\TerminalItem
     */
    public function setState($state = null)
    {
        // validation for constraint: string
        if (!is_null($state) && !is_string($state)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($state, true), gettype($state)), __LINE__);
        }
        $this->State = $state;
        return $this;
    }
    /**
     * Get Zipcode value
     * @return string|null
     */
    public function getZipcode()
    {
        return $this->Zipcode;
    }
    /**
     * Set Zipcode value
     * @param string $zipcode
     * @return \StructType\TerminalItem
     */
    public function setZipcode($zipcode = null)
    {
        // validation for constraint: string
        if (!is_null($zipcode) && !is_string($zipcode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($zipcode, true), gettype($zipcode)), __LINE__);
        }
        $this->Zipcode = $zipcode;
        return $this;
    }
}
